unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, ExtDlgs;

type
  TForm1 = class(TForm)
    Image2: TImage;
    Image3: TImage;
    Image1: TImage;
    PaintBox1: TPaintBox;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label1: TLabel;
    Label8: TLabel;
    Button1: TButton;
    Label9: TLabel;
    Label10: TLabel;
    LblX: TLabel;
    LblY: TLabel;
    LblRotate: TLabel;
    LblRate: TLabel;
    Label11: TLabel;
    Label2: TLabel;
    LblFitness: TLabel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    FDragging: Boolean;
    FStartPos: TPoint;
  public

  end;

var
  Form1: TForm1;

implementation

uses
    ImgHolder;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    PaintBox1.ControlStyle := PaintBox1.ControlStyle + [csOpaque];

    //  }EX쒆ǂ
    FDragging := False;

    //  `pyCg{bNX̃TCY낦
    PaintBox1.BoundsRect := Image1.BoundsRect;

    //  摜NXɃZbg
    GImageHolder.Image := Image1.Picture.Bitmap;

    //  ev[g摜NXɃZbg
    GImageHolder.ClearTemplate();
    GImageHolder.AddTemplate(Image2.Picture.Bitmap);

    //  O[XP[ϊꂽ̂߂ēǂݍ
    Image1.Picture.Bitmap.Assign(GImageHolder.Image);

    //  O[XP[ϊꂽ̂߂ēǂݍ
    Image2.Picture.Bitmap.Assign(GImageHolder.Template[0]);

    //  p[^ݒ
    Button1Click(nil);
end;

//-----------------------------------------------------------------------------
//  p[^
procedure TForm1.Button1Click(Sender: TObject);
begin
    LblX.Tag := 0;
    LblY.Tag := 0;
    LblRotate.Tag := 0;
    LblRate.Tag := 100;

    //  p[^\
    LblX.Caption := IntToStr(LblX.Tag);
    LblY.Caption := IntToStr(LblY.Tag);
    LblRotate.Caption := IntToStr(LblRotate.Tag) + '[deg]';
    LblRate.Caption := IntToStr(LblRate.Tag) + '[%]';

    //  ĕ`
    PaintBox1.Repaint();
end;

//-----------------------------------------------------------------------------
//  Jn
procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  쒆tOON
    FDragging := True;
    //  Jn_L^
    FStartPos := Point(X, Y);
end;

//-----------------------------------------------------------------------------
//  쒆
procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
    Pt: TPoint;
begin
    //  ̓_L^
    Pt := Point(X, Y);

    //  쒆tOONȂ
    if (FDragging) then
    begin
        //  sړ[h
        if (SpeedButton2.Down) then
        begin
            //  Ɉړ
            LblX.Tag := LblX.Tag + (Pt.X - FStartPos.X);
            //  cɈړ
            LblY.Tag := LblY.Tag + (Pt.Y - FStartPos.Y);
            //  
            if (LblX.Tag < 0) then
            begin
                LblX.Tag := 0;
            end
            else if (LblX.Tag > PaintBox1.Width - Image2.Width) then
            begin
                LblX.Tag := PaintBox1.Width - Image2.Width;
            end;
            if (LblY.Tag < 0) then
            begin
                LblY.Tag := 0;
            end
            else if (LblY.Tag > PaintBox1.Height - Image2.Height) then
            begin
                LblY.Tag := PaintBox1.Height - Image2.Height;
            end;
            //  ̑ɔďJn_XV
            FStartPos := Pt;
        end

        //  ]ړ[h
        else if (SpeedButton3.Down) then
        begin
            //  ]
            LblRotate.Tag := LblRotate.Tag + (Pt.X - FStartPos.X);
            //  ](͂ȂĂeXgɂ͂Ȃ邯ǂł)
            LblRotate.Tag := LblRotate.Tag + (Pt.Y - FStartPos.Y);
            //  ̑ɔďJn_XV
            FStartPos := Pt;
        end

        //  g僂[h
        else if (SpeedButton4.Down) then
        begin
            //  g傠邢͏k
            LblRate.Tag := LblRate.Tag + (Pt.X - FStartPos.X);
            //  g傠邢͏k()
            LblRate.Tag := LblRate.Tag + (Pt.Y - FStartPos.Y);
            //  
            if (LblRate.Tag < 10) then LblRate.Tag := 10
            else if (LblRate.Tag > 1000) then LblRate.Tag := 1000;
            //  ̑ɔďJn_XV
            FStartPos := Pt;
        end;

        //  p[^\
        LblX.Caption := IntToStr(LblX.Tag);
        LblY.Caption := IntToStr(LblY.Tag);
        LblRotate.Caption := IntToStr(LblRotate.Tag) + '[deg]';
        LblRate.Caption := IntToStr(LblRate.Tag) + '[%]';

        //  ĕ`
        PaintBox1.Repaint();
    end;
end;

//-----------------------------------------------------------------------------
//  m
procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (FDragging) then
    begin
        PaintBox1MouseMove(PaintBox1, Shift, X, Y);
        FDragging := False;
    end;
end;

//-----------------------------------------------------------------------------
//  `(摜ƕ]摜̈ʒuƕ])
procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
    //  摜`
    BitBlt(PaintBox1.Canvas.Handle, 0, 0, PaintBox1.Width, PaintBox1.Height,
            Image1.Picture.Bitmap.Canvas.Handle, 0, 0, SRCCOPY);

    //  ]
    LblFitness.Caption :=
        FormatFloat('0.00', GImageHolder.Eval(0, LblX.Tag, LblY.Tag, LblRotate.Tag, LblRate.Tag / 100));

    //  ]Ɏgp摜\
    Image3.Picture.Bitmap.Assign(GImageHolder.EvalBuf);

    //  摜ɏd˂`ŕ]Ώۂ̗̈`
    PaintBox1.Canvas.Pen.Color := clRed;
    GImageHolder.Rotater.DrawResult(PaintBox1.Canvas, False);
    PaintBox1.Canvas.Pen.Color := clBlack;
end;

end.
